part of fcm_config;

mixin FCMNotificationClickMixin<T extends StatefulWidget> on State<T> {
  @override
  void initState() {
    _clickListner.addListener(_onClick);
    super.initState();
  }

  @override
  void dispose() {
    _clickListner.removeListener(_onClick);

    super.dispose();
  }

  void onClick(FCMNotification notification);

  void _onClick() => onClick(_clickListner.value);
}

class FCMNotificationClickListener extends StatefulWidget {
  final Widget child;
  final Function(FCMNotification notification, VoidCallback setState)
      onNotificationClick;
  const FCMNotificationClickListener(
      {Key key, @required this.child, @required this.onNotificationClick})
      : super(key: key);
  @override
  _FCMNotificationClickState createState() => _FCMNotificationClickState();
}

class _FCMNotificationClickState extends State<FCMNotificationClickListener>
    with FCMNotificationClickMixin {
  @override
  Widget build(BuildContext context) {
    return widget.child;
  }

  @override
  void onClick(FCMNotification notification) {
    widget.onNotificationClick(notification, () {
      if (mounted) setState(() {});
    });
  }
}
