part of fcm_config;

mixin FCMNotificationMixin<T extends StatefulWidget> on State<T> {
  @override
  void initState() {
    _listener.addListener(_onNewNotify);
    super.initState();
  }

  @override
  void dispose() {
    _listener.removeListener(_onNewNotify);

    super.dispose();
  }

  void onNotify(FCMNotification notification);

  void _onNewNotify() => onNotify(_listener.value);
}

class FCMNotificationListener extends StatefulWidget {
  final Widget child;
  final Function(FCMNotification notification, VoidCallback setState)
      onNotification;
  const FCMNotificationListener(
      {Key key, @required this.child, @required this.onNotification})
      : super(key: key);
  @override
  _FCMNotificationListenerState createState() =>
      _FCMNotificationListenerState();
}

class _FCMNotificationListenerState extends State<FCMNotificationListener>
    with FCMNotificationMixin {
  @override
  Widget build(BuildContext context) {
    return widget.child;
  }

  @override
  void onNotify(FCMNotification notification) {
    widget.onNotification(notification, () {
      if (mounted) setState(() {});
    });
  }
}
